searchData={"items":[{"type":"task","doc":"Interactive test runner for ExUnit tests.\n\n`mix test.interactive` allows you to easily switch between running all tests,\nstale tests, or failed tests. Or, you can run only the tests whose filenames\ncontain a substring. You can also control which tags are included or excluded,\nmodify the maximum number of failures allowed, repeat the test suite until a\nfailure occurs, specify the test seed to use, and toggle tracing on and off.\nIncludes an optional \"watch mode\" which runs tests after every file change.","title":"mix test.interactive","ref":"Mix.Tasks.Test.Interactive.html"},{"type":"task","doc":"```shell\nmix test.interactive   [--  ]\nmix test.interactive  \nmix test.interactive --help\nmix test.interactive --version\n```\n\nYour tests will run immediately (and every time a file changes).","title":"Usage - mix test.interactive","ref":"Mix.Tasks.Test.Interactive.html#module-usage"},{"type":"task","doc":"`mix test.interactive` understands the following options, most of which\ncorrespond to configuration settings below.\n\nNote that, if you want to pass both mix test.interactive options and mix test\narguments, you must separate them with `--`.\n\nIf an option is provided on the command line, it will override the same option\nspecified in the configuration.\n\n- `--(no-)clear`: Clear the console before each run (default `false`).\n- `--command   [--arg  ]`: Custom command and arguments for\n  running tests (default: \"mix\" with no arguments). NOTE: Use `--arg` multiple\n  times to specify more than one argument.\n- `--exclude  `: Exclude files/directories from triggering test runs\n  (default: `[\"~r/.#/\", \"~r{priv/repo/migrations}\"`]) NOTE: Use `--exclude`\n  multiple times to specify more than one regex.\n- `--extra-extensions  `: Watch files with additional extensions\n  (default: []).\n- `--runner  `: Use a custom runner module (default:\n  `MixTestInteractive.PortRunner`).\n- `--task  `: Run a different mix task (default: `\"test\"`).\n- `--(no-)timestamp`: Display the current time before running the tests\n  (default: `false`).\n- `--(no-)watch`: Don't run tests when a file changes (default: `true`).\n\nAll of the ` ` are passed through to `mix test` on every\ntest run.\n\n`mix test.interactive` will detect the `--exclude`, `--failed`, `--include`,\n`--only`, `--seed`, and `--stale` options and use those as initial settings in\ninteractive mode. You can then use the interactive mode commands to adjust\nthose options as needed. It will also detect any filename or pattern arguments\nand use those as initial settings. Note that if you specify a pattern on the\ncommand-line, `mix test.interactive` will find all test files matching that\npattern and pass those to `mix test` as if you had used the `p` command.","title":"Options - mix test.interactive","ref":"Mix.Tasks.Test.Interactive.html#module-options"},{"type":"task","doc":"`mix test.interactive` can take the same filename or filename:line_number\npatterns that `mix test` understands. It also allows you to specify one or\nmore \"patterns\" - strings that match one or more test files. When you provide\none or more patterns on the command-line, `mix test.interactive` will find all\ntest files matching those patterns and pass them to `mix test` as if you had\nused the `p` command (described below).","title":"Patterns and filenames - mix test.interactive","ref":"Mix.Tasks.Test.Interactive.html#module-patterns-and-filenames"},{"type":"task","doc":"After the tests run, you can use the interactive commands to change which\ntests will run.\n\n- `a`: Run all tests. Clears the `--failed` and `--stale` options as well as\n  any patterns.\n- `d  `: Run the tests with a specific seed.\n- `d`: Clear any previously specified seed.\n- `f`: Run only tests that failed on the last run (equivalent to the\n`--failed` option of `mix test`).\n- `i  `: Include tests tagged with the listed tags (equivalent to the\n  `--include` option of `mix test`).\n- `i`: Clear any included tags.\n- `m  `: Specify the maximum number of failures allowed (equivalent to the\n  `--max-failures` option of `mix test`).\n- `m`: Clear any previously specified maximum number of failures.\n- `o  `: Run only tests tagged with the listed tags (equivalent to the\n  `--only` option of `mix test`).\n- `o`: Clear any \"only\" tags.\n- `p`: Run only test files that match one or more provided patterns. A pattern\n  is the project-root-relative path to a test file (with or without a line\n  number specification) or a string that matches a portion of full pathname.\n  e.g. `test/my_project/my_test.exs`, `test/my_project/my_test.exs:12:24` or\n  `my`.\n- `q`: Exit the program. (Can also use `Ctrl-D`.)\n- `r  `: (Elixir 1.17.0 and later) Run tests up to   times until a\n  failure occurs (equivalent to the `--repeat-until-failure` option of `mix\n  test`).\n- `r`: (Elixir 1.17.0 and later) Clear the \"repeat-until-failure\" count.\n- `s`: Run only test files that reference modules that have changed since the\n  last run (equivalent to the `--stale` option of `mix test`).\n- `t`: Turn test tracing on or off (equivalent to the `--trace` option of `mix\n  test`).\n- `x  `: Exclude tests tagged with the listed tags (equivalent to the\n  `--exclude` option of `mix test`).\n- `x`: Clear any excluded tags.\n- `w`: Turn file-watching mode on or off.\n- `Enter`: Re-run the current set of tests without requiring a file change.\n- `?`: Show usage help.","title":"Interactive Commands - mix test.interactive","ref":"Mix.Tasks.Test.Interactive.html#module-interactive-commands"},{"type":"task","doc":"If your project has a `config/config.exs` file, you can customize the\noperation of `mix test.interactive` with the following settings:\n\n- `clear: true`: Clear the console before each run (default: `false`).\n- `command:  ` or `command: { , [ , ...]}`: Use the\n  provided command and arguments to run the test task (default: `mix`).\n- `exclude: [patterns...]`: A list of `Regex`es to ignore when watching for\n  changes (default: `[~r/.#/, ~r{priv/repo/migrations}]`).\n- `extra_extensions: [ ...]`: Additional filename extensions to include\n  when watching for file changes (default: `[]`).\n- `runner:  `: A custom runner for running the tests (default:\n  `MixTestInteractive.PortRunner`).\n- `task:  `: The mix task to use when running tests (default:\n  `\"test\"`).\n- `timestamp: true`: Print current time (UTC) before running tests (default:\n  false).","title":"Configuration - mix test.interactive","ref":"Mix.Tasks.Test.Interactive.html#module-configuration"},{"type":"function","doc":"","title":"Mix.Tasks.Test.Interactive.run/1","ref":"Mix.Tasks.Test.Interactive.html#run/1"},{"type":"module","doc":"Interactively run your Elixir project's tests.","title":"MixTestInteractive","ref":"MixTestInteractive.html"},{"type":"function","doc":"Start the interactive test runner.","title":"MixTestInteractive.run/1","ref":"MixTestInteractive.html#run/1"},{"type":"behaviour","doc":"Behaviour for interactive mode commands.\n\nAll commands must implement this behaviour.\n\nIt is recommended to `use` this module in the command's module:\n\n```\ndefmodule MyCommand do\n  use MixTestInteractive.Command,\n    command: \"c\",\n    desc: \"do the thing\"\n\n  # ...\nend\n```\n\nThis will provide overridable implementations of most of the callbacks.\n\n`:command` is the key sequence the user will use to invoke the command. If a more appropriate\ncommand name is required in the help text, you can override the `name/0` callback.\n\n`:desc` is the command's description.\n\n`:command` and `:desc` should be written so that the following pattern reads nicely in the\nusage output: `  to  `. For example, `a to run all tests`.","title":"MixTestInteractive.Command","ref":"MixTestInteractive.Command.html"},{"type":"callback","doc":"Is the command applicable given the current configuration?\n\nReturns `true` by default if not overridden.","title":"MixTestInteractive.Command.applies?/1","ref":"MixTestInteractive.Command.html#c:applies?/1"},{"type":"callback","doc":"The command's key sequence.\n\nKey sequences should be short (single character preferred) and unique.\n\nReturns the value of the `:command` argument passed in the `use` statement.\n\nNot overridable.","title":"MixTestInteractive.Command.command/0","ref":"MixTestInteractive.Command.html#c:command/0"},{"type":"callback","doc":"The command's description.\n\nDescriptions should be written to fit the pattern `  to  `.\nFor example, `a to run all tests`.\n\nReturns the value of the `:desc` argument passed in the `use` statement.\n\nNot overridable.","title":"MixTestInteractive.Command.description/0","ref":"MixTestInteractive.Command.html#c:description/0"},{"type":"callback","doc":"The command's name.\n\nReadable name for the command.\n\nDefaults to the `command/0`, but can be overridden to make usage output clearer.","title":"MixTestInteractive.Command.name/0","ref":"MixTestInteractive.Command.html#c:name/0"},{"type":"callback","doc":"Execute the command.\n\nPerforms the desired action in response to the command.\n\nMost commands return an `:ok` tuple with an updated configuration, allowing\n`MixTestInteractive.InteractiveMode` to run the tests with the new configuration.\n\nA command can return a `:no_run` tuple with an updated configuration if the tests\nshould not be run in response to the command.\n\nA command can return `:help` to show detailed usage information, or `:quit` to\nexit `mix test.interactive`.\n\nNo default provided.","title":"MixTestInteractive.Command.run/2","ref":"MixTestInteractive.Command.html#c:run/2"},{"type":"type","doc":"","title":"MixTestInteractive.Command.response/0","ref":"MixTestInteractive.Command.html#t:response/0"},{"type":"module","doc":"Processes interactive mode commands.","title":"MixTestInteractive.CommandProcessor","ref":"MixTestInteractive.CommandProcessor.html"},{"type":"function","doc":"Processes a single interactive mode command.","title":"MixTestInteractive.CommandProcessor.call/2","ref":"MixTestInteractive.CommandProcessor.html#call/2"},{"type":"function","doc":"Returns an ANSI-formatted usage summary.\n\nIncludes only commands that are applicable to the current configuration.","title":"MixTestInteractive.CommandProcessor.usage/1","ref":"MixTestInteractive.CommandProcessor.html#usage/1"},{"type":"type","doc":"","title":"MixTestInteractive.CommandProcessor.response/0","ref":"MixTestInteractive.CommandProcessor.html#t:response/0"},{"type":"module","doc":"Configuration for the task.","title":"MixTestInteractive.Config","ref":"MixTestInteractive.Config.html"},{"type":"function","doc":"Create a new config struct, taking values from the application environment.","title":"MixTestInteractive.Config.load_from_environment/0","ref":"MixTestInteractive.Config.html#load_from_environment/0"},{"type":"type","doc":"","title":"MixTestInteractive.Config.t/0","ref":"MixTestInteractive.Config.html#t:t/0"},{"type":"module","doc":"Server for interactive mode.\n\nProcesses commands from the user and requests to run tests due to file changes.\nThis ensures that commands cannot be processed while tests are already running.\n\nAny commands that come in while the tests are running will be processed once the\ntest run has completed.","title":"MixTestInteractive.InteractiveMode","ref":"MixTestInteractive.InteractiveMode.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"MixTestInteractive.InteractiveMode.child_spec/1","ref":"MixTestInteractive.InteractiveMode.html#child_spec/1"},{"type":"function","doc":"Tell InteractiveMode that one or more files have changed.","title":"MixTestInteractive.InteractiveMode.note_file_changed/1","ref":"MixTestInteractive.InteractiveMode.html#note_file_changed/1"},{"type":"function","doc":"Process a command from the user.","title":"MixTestInteractive.InteractiveMode.process_command/2","ref":"MixTestInteractive.InteractiveMode.html#process_command/2"},{"type":"function","doc":"Start the interactive mode server.","title":"MixTestInteractive.InteractiveMode.start_link/1","ref":"MixTestInteractive.InteractiveMode.html#start_link/1"},{"type":"type","doc":"","title":"MixTestInteractive.InteractiveMode.option/0","ref":"MixTestInteractive.InteractiveMode.html#t:option/0"},{"type":"module","doc":"Run the tasks in a new OS process via `Port`s.\n\nOn Unix-like operating systems, it runs the tests using a `zombie_killer` script\nas described in https://hexdocs.pm/elixir/Port.html#module-zombie-operating-system-processes.\nIt also enables ANSI output mode.\n\nOn Windows, `mix` is run directly and ANSI mode is not enabled, as it is not always\nsupported by Windows command processors.","title":"MixTestInteractive.PortRunner","ref":"MixTestInteractive.PortRunner.html"},{"type":"function","doc":"Run tests based on the current configuration.","title":"MixTestInteractive.PortRunner.run/4","ref":"MixTestInteractive.PortRunner.html#run/4"},{"type":"type","doc":"","title":"MixTestInteractive.PortRunner.os_type/0","ref":"MixTestInteractive.PortRunner.html#t:os_type/0"},{"type":"type","doc":"","title":"MixTestInteractive.PortRunner.runner/0","ref":"MixTestInteractive.PortRunner.html#t:runner/0"},{"type":"module","doc":"Runs tests based on current configuration.\n\nAlso responsible for optionally clearing the terminal and printing the current time.","title":"MixTestInteractive.Runner","ref":"MixTestInteractive.Runner.html"},{"type":"function","doc":"Run tests using configured runner.","title":"MixTestInteractive.Runner.run/2","ref":"MixTestInteractive.Runner.html#run/2"},{"type":"module","doc":"Interactive mode settings.\n\nKeeps track of the current settings of `MixTestInteractive.InteractiveMode`, making changes\nin response to user commands.","title":"MixTestInteractive.Settings","ref":"MixTestInteractive.Settings.html"},{"type":"function","doc":"Update settings to run all tests, removing any flags or filter patterns.","title":"MixTestInteractive.Settings.all_tests/1","ref":"MixTestInteractive.Settings.html#all_tests/1"},{"type":"function","doc":"Update settings to clear any excluded tags.","title":"MixTestInteractive.Settings.clear_excludes/1","ref":"MixTestInteractive.Settings.html#clear_excludes/1"},{"type":"function","doc":"Update settings to clear any included tags.","title":"MixTestInteractive.Settings.clear_includes/1","ref":"MixTestInteractive.Settings.html#clear_includes/1"},{"type":"function","doc":"Update settings to run with unlimited failures, clearing any specified maximum\nnumber of failures.","title":"MixTestInteractive.Settings.clear_max_failures/1","ref":"MixTestInteractive.Settings.html#clear_max_failures/1"},{"type":"function","doc":"Update settings to clear any \"only\" tags.","title":"MixTestInteractive.Settings.clear_only/1","ref":"MixTestInteractive.Settings.html#clear_only/1"},{"type":"function","doc":"Update settings to run tests only once, clearing any repeat-until-failure\ncount.","title":"MixTestInteractive.Settings.clear_repeat_count/1","ref":"MixTestInteractive.Settings.html#clear_repeat_count/1"},{"type":"function","doc":"Update settings to run tests with a random seed, clearing any specified seed.","title":"MixTestInteractive.Settings.clear_seed/1","ref":"MixTestInteractive.Settings.html#clear_seed/1"},{"type":"function","doc":"Assemble command-line arguments to pass to `mix test`.\n\nIncludes arguments originally passed to `mix test.interactive` when it was started\nas well as arguments based on the current interactive mode settings.","title":"MixTestInteractive.Settings.cli_args/1","ref":"MixTestInteractive.Settings.html#cli_args/1"},{"type":"function","doc":"Update settings to only run failing tests.\n\nCorresponds to `mix test --failed`.","title":"MixTestInteractive.Settings.only_failed/1","ref":"MixTestInteractive.Settings.html#only_failed/1"},{"type":"function","doc":"Provide a list of file-name filter patterns.\n\nOnly test filenames matching one or more patterns will be run.","title":"MixTestInteractive.Settings.only_patterns/2","ref":"MixTestInteractive.Settings.html#only_patterns/2"},{"type":"function","doc":"Update settings to only run \"stale\" tests.\n\nCorresponds to `mix test --stale`.","title":"MixTestInteractive.Settings.only_stale/1","ref":"MixTestInteractive.Settings.html#only_stale/1"},{"type":"function","doc":"Return a text summary of the current interactive mode settings.","title":"MixTestInteractive.Settings.summary/1","ref":"MixTestInteractive.Settings.html#summary/1"},{"type":"function","doc":"Toggle test tracing on or off.","title":"MixTestInteractive.Settings.toggle_tracing/1","ref":"MixTestInteractive.Settings.html#toggle_tracing/1"},{"type":"function","doc":"Toggle file-watching mode on or off.","title":"MixTestInteractive.Settings.toggle_watch_mode/1","ref":"MixTestInteractive.Settings.html#toggle_watch_mode/1"},{"type":"function","doc":"Exclude tests with the specified tags.\n\nCorresponds to `mix test --exclude   --exclude   ...`.","title":"MixTestInteractive.Settings.with_excludes/2","ref":"MixTestInteractive.Settings.html#with_excludes/2"},{"type":"function","doc":"Include tests with the specified tags.\n\nCorresponds to `mix test --include   --include   ...`.","title":"MixTestInteractive.Settings.with_includes/2","ref":"MixTestInteractive.Settings.html#with_includes/2"},{"type":"function","doc":"Stop running tests after a maximum number of failures.\n\nCorresponds to `mix test --max-failures  `.","title":"MixTestInteractive.Settings.with_max_failures/2","ref":"MixTestInteractive.Settings.html#with_max_failures/2"},{"type":"function","doc":"Run only the tests with the specified tags.\n\nCorresponds to `mix test --only   --only   ...`.","title":"MixTestInteractive.Settings.with_only/2","ref":"MixTestInteractive.Settings.html#with_only/2"},{"type":"function","doc":"Update settings to run tests   times until failure.\n\nCorresponds to `mix test --repeat-until-failure  `.","title":"MixTestInteractive.Settings.with_repeat_count/2","ref":"MixTestInteractive.Settings.html#with_repeat_count/2"},{"type":"function","doc":"Update settings to run tests with a specific seed.\n\nCorresponds to `mix test --seed  `.","title":"MixTestInteractive.Settings.with_seed/2","ref":"MixTestInteractive.Settings.html#with_seed/2"},{"type":"type","doc":"","title":"MixTestInteractive.Settings.t/0","ref":"MixTestInteractive.Settings.html#t:t/0"},{"type":"behaviour","doc":"Behaviour for custom test runners.\n\nAny custom runner defined in the configuration or by command-line options must\nimplement this behaviour, either explicitly or implicitly.","title":"MixTestInteractive.TestRunner","ref":"MixTestInteractive.TestRunner.html"},{"type":"callback","doc":"","title":"MixTestInteractive.TestRunner.run/2","ref":"MixTestInteractive.TestRunner.html#c:run/2"},{"type":"module","doc":"A server that runs tests whenever source files change.","title":"MixTestInteractive.Watcher","ref":"MixTestInteractive.Watcher.html"},{"type":"function","doc":"Returns a specification to start this module under a supervisor.\n\nSee `Supervisor`.","title":"MixTestInteractive.Watcher.child_spec/1","ref":"MixTestInteractive.Watcher.html#child_spec/1"},{"type":"function","doc":"Start the file watcher.","title":"MixTestInteractive.Watcher.start_link/1","ref":"MixTestInteractive.Watcher.html#start_link/1"},{"type":"module","doc":"Run all tests, removing any flags or filters.","title":"MixTestInteractive.Command.AllTests","ref":"MixTestInteractive.Command.AllTests.html"},{"type":"module","doc":"Specify or clear tags to exclude.\n\nRuns the tests excluding the given tags if provided. If not provided, the\nexcludes are cleared and the tests will run with any excludes configured in\nyour `ExUnit.configure/1` call (if any).","title":"MixTestInteractive.Command.Exclude","ref":"MixTestInteractive.Command.Exclude.html"},{"type":"module","doc":"Run only failed tests.\n\nEquivalent to `mix test --failed`.","title":"MixTestInteractive.Command.Failed","ref":"MixTestInteractive.Command.Failed.html"},{"type":"module","doc":"Show detailed usage information.\n\nLists all commands applicable to the current context.","title":"MixTestInteractive.Command.Help","ref":"MixTestInteractive.Command.Help.html"},{"type":"module","doc":"Specify or clear tags to include.\n\nRuns the tests excluding the given tags if provided. If not provided, the\nincludes are cleared and the tests will run with any includes configured in\nyour `ExUnit.configure/1` call (if any).","title":"MixTestInteractive.Command.Include","ref":"MixTestInteractive.Command.Include.html"},{"type":"module","doc":"Specify or clear the maximum number of failures during a test run.\n\nRuns the tests with the given maximum failures if provided. If not provided,\nthe max is cleared and the tests will run until completion as usual.","title":"MixTestInteractive.Command.MaxFailures","ref":"MixTestInteractive.Command.MaxFailures.html"},{"type":"module","doc":"Specify or clear the only tags to run.\n\nRuns the tests with only the given tags if provided. If not provided, the list\nof only tags is cleared and the tests will run with any only configured in\nyour `ExUnit.configure/1` call (if any).","title":"MixTestInteractive.Command.Only","ref":"MixTestInteractive.Command.Only.html"},{"type":"module","doc":"Specify one or more filename-matching patterns.\n\nRuns all tests that contain at least one of the patterns as a substring of their filename.\n\nIf any pattern looks like a filename/line number pattern, then all of the patterns\nare passed on to `mix test` directly; no filtering is done.  This is because `mix test`\nonly supports a single filename-with-line-number pattern at a time.","title":"MixTestInteractive.Command.Pattern","ref":"MixTestInteractive.Command.Pattern.html"},{"type":"module","doc":"Exit mix test.interactive.","title":"MixTestInteractive.Command.Quit","ref":"MixTestInteractive.Command.Quit.html"},{"type":"module","doc":"Specify or clear the number of repetitions for running until failure.\n\nRuns the tests repeatedly until failure or until the specified number of runs.\nIf not provided, the count is cleared and the tests will run just once as\nusual.\n\nCorresponds to `mix test --repeat-until-failure  `.\n\nThis option is only available in `mix test` in Elixir 1.17.0 and later.","title":"MixTestInteractive.Command.RepeatUntilFailure","ref":"MixTestInteractive.Command.RepeatUntilFailure.html"},{"type":"module","doc":"Run all tests matching the current flags and filter settings.","title":"MixTestInteractive.Command.RunTests","ref":"MixTestInteractive.Command.RunTests.html"},{"type":"module","doc":"Specify or clear the random number seed for test runs.\n\nRuns the tests with the given seed if provided. If not provided, the seed is\ncleared and the tests will run with a random seed as usual.","title":"MixTestInteractive.Command.Seed","ref":"MixTestInteractive.Command.Seed.html"},{"type":"module","doc":"Run only stale tests.\n\nEquivalent to `mix test --stale`.","title":"MixTestInteractive.Command.Stale","ref":"MixTestInteractive.Command.Stale.html"},{"type":"module","doc":"Toggle test tracing on or off.\n\nRuns the tests in trace mode when tracing is on and normally when off.\n\nCorresponds to `mix test --trace`.","title":"MixTestInteractive.Command.ToggleTracing","ref":"MixTestInteractive.Command.ToggleTracing.html"},{"type":"module","doc":"Toggle file-watching mode on or off.\n\nWhen watch mode is on, `mix test.interactive` will re-run the\ncurrent set of tests whenever a file changes.\n\nWhen it is off, tests must be run manually, either by changing\nusing a command to change the configuration, or by using the\n`MixTestInteractive.Command.RunTests` command.","title":"MixTestInteractive.Command.ToggleWatchMode","ref":"MixTestInteractive.Command.ToggleWatchMode.html"},{"type":"extras","doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](https://keepachangelog.com/en/1.0.0/),\nand this project adheres to [Semantic Versioning](https://semver.org/spec/v2.0.0.html).\n\n## [Unreleased](https://github.com/randycoulman/mix_test_interactive/compare/v4.1.2...HEAD)\n\n## [v4.1.2](https://github.com/randycoulman/mix_test_interactive/compare/v4.1.1...v4.1.2) - 2024-12-14","title":"Changelog","ref":"changelog.html"},{"type":"extras","doc":"- Update README with instructions for running `mix test.interactive` as an independent script that doesn't require installing as a dependency in your application. ([#127](https://github.com/randycoulman/mix_test_interactive/pull/127) - Thanks [@andyl](https://github.com/andyl)!)\n\n- Allow process_tree versions v0.1.3 and v0.2.0 to provide more flexibility for upstream projects ([#128](https://github.com/randycoulman/mix_test_interactive/pull/128))\n\n## [v4.1.1](https://github.com/randycoulman/mix_test_interactive/compare/v4.1.0...v4.1.1) - 2024-09-28","title":"Updated - Changelog","ref":"changelog.html#updated"},{"type":"extras","doc":"- Properly handle `mix test.interactive  ` case. The new command-line parsing added in v4.0 was not properly capturing the filenames/patterns and passing them on to `mix test`. ([#123](https://github.com/randycoulman/mix_test_interactive/pull/123) - Thanks [@jfpedroza](https://github.com/jfpedroza) for finding and reporting the bug!)\n\n## [v4.1.0](https://github.com/randycoulman/mix_test_interactive/compare/v4.0.0...v4.1.0) - 2024-09-21","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"- This version adds a number of new commands for controlling additional `mix test` options interactively:\n\n  - `d  `/`d`: Set or clear the seed to use when running tests (`mix test --seed  `). ([#112](https://github.com/randycoulman/mix_test_interactive/pull/112))\n  - `i  `/`i`: Set or clear tags to include (`mix test --include   --include  ...`). ([#113](https://github.com/randycoulman/mix_test_interactive/pull/113))\n  - `o  `/`o`: Set or clear \"only\" tags (`mix test --only   --only  ...`). ([#113](https://github.com/randycoulman/mix_test_interactive/pull/113))\n  - `x  `/`x`: Set or clear tags to exclude (`mix test --exclude   --exclude  ...`). ([#113](https://github.com/randycoulman/mix_test_interactive/pull/113))\n  - `m  `/`m`: Set or clear the maximum number of failures to allow (`mix test --max-failures  `). ([#116](https://github.com/randycoulman/mix_test_interactive/pull/116))\n  - `r  /`/`r`: Set or clear the maximum number of repeated runs until a test failure (`mix test --repeat-until-failure  `). **NOTE:** `mix test` only supports this option in v1.17.0 and later. ([#118](https://github.com/randycoulman/mix_test_interactive/pull/118))\n  - `t`: Toggle test tracing on/off (`mix test --trace`). ([#117](https://github.com/randycoulman/mix_test_interactive/pull/112))\n\n- There is now a `MixTestInteractive.TestRunner` behaviour for use in custom test runners. Up until now, custom test runners needed to implement a single `run/2` function. This release adds a behaviour that custom test runners can implement to ensure that they've correctly conformed to the interface. Custom test runners don't have to explicitly implement the behaviour, but must implicitly do so as before. ([#115](https://github.com/randycoulman/mix_test_interactive/pull/115))\n\n## [v4.0.0](https://github.com/randycoulman/mix_test_interactive/compare/v3.2.1...v4.0.0) - 2024-09-13","title":"Added - Changelog","ref":"changelog.html#added"},{"type":"extras","doc":"This version introduces the option of \"config-less\" operation. All configuration settings can now be supplied on the command-line instead. To avoid confusion and clashes with `mix test`'s command-line options, it is now necessary to separate `mix test.interactive`'s options from `mix test`'s options with `--` separator.\n\nFor example, to use the new `--clear` option as well as `mix test`'s `--stale` option, it is necessary to use:\n\n```shell\nmix test.interactive --clear -- --stale\n```\n\nThis affects two of the command-line options that were available in previous versions:\n\n- `mix test.interactive`'s `--no-watch` flag. Previously, you could run (for example) `mix test.interactive --no-watch --stale`. This will no longer work. You must now use `mix test.interactive --no-watch -- --stale` instead.\n- `mix test`'s `--exclude` option. `mix test.interactive` now has its own `--exclude` option. Previously, you could run (for example) `mix test.interactive --exclude some_test_tag` and that argument would be forwarded on to `mix test`. Now you must use `mix test.interactive -- --exclude some_test_tag` instead.\n\nIf you don't use either of these two options, everything should work as before.\n\nTo upgrade to this version, you'll need to update any `mix` aliases or other scripts you may have defined for `mix test.interactive`. In addition, you and everyone who works in your codebase will need to update any shell aliases they have defined.","title":"💥 BREAKING CHANGE 💥 - Changelog","ref":"changelog.html#breaking-change"},{"type":"extras","doc":"- This version introduces the option of \"config-less\" operation. All configuration settings can now be supplied on the command-line instead. See the [README](https://github.com/randycoulman/mix_test_interactive/blob/main/README.md) or run `mix help test.interactive` for more information. Also, see the `💥 BREAKING CHANGE 💥` section above. ([#108](https://github.com/randycoulman/mix_test_interactive/pull/108))","title":"Added - Changelog","ref":"changelog.html#added"},{"type":"extras","doc":"- The `Running tests...` message that `mix test.interactive` displays before each test run is displayed in color. This makes it easier to find the most recent test run when scrolling back in your shell. ([#109](https://github.com/randycoulman/mix_test_interactive/pull/109))\n\n## [v3.2.1](https://github.com/randycoulman/mix_test_interactive/compare/v3.2.0...v3.2.1) - 2024-09-07","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"- Fixed handling of custom `command`/`args` on Unix-like systems. `mix_test_interactive` was not correctly ordering the various arguments. ([#105](https://github.com/randycoulman/mix_test_interactive/pull/105) - Thanks [@callmiy](https://github.com/callmiy)!)\n\n## [v3.2.0](https://github.com/randycoulman/mix_test_interactive/compare/v3.1.0...v3.2.0) - 2024-08-24","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"- Made pattern matching more flexible. Previously, when given multiple patterns, we would not do any file filtering if any of the patterns was a `file:line`-style pattern. Instead, we'd pass all of the patterns to `mix test` literally. Now, we run normal file filtering for any non-`file:line`-style patterns and concatenate the results with any `file:line`-style patterns. ([#99](https://github.com/randycoulman/mix_test_interactive/pull/99))\n- Added documentation for missing configuration options in the mix task's module documentation. ([#100](https://github.com/randycoulman/mix_test_interactive/pull/100))\n\n## [v3.1.0](https://github.com/randycoulman/mix_test_interactive/compare/v3.0.0...v3.1.0) - 2024-08-24","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"- Add a new `command` configuration option that allows use of a custom command instead of `mix` for running tests. See the [README](https://github.com/randycoulman/mix_test_interactive#command-use-a-custom-command) for more details. ([#96](https://github.com/randycoulman/mix_test_interactive/pull/96))","title":"Added - Changelog","ref":"changelog.html#added"},{"type":"extras","doc":"- Added [documentation for missing configuration options](https://github.com/randycoulman/mix_test_interactive#configuration) in the README. ([#96](https://github.com/randycoulman/mix_test_interactive/pull/96))\n\n## [v3.0.0](https://github.com/randycoulman/mix_test_interactive/compare/v2.1.0...v3.0.0) - 2024-07-13","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"- This release drops support for Elixir 1.12. We officially support the\n  [same versions as Elixir\n  itself](https://hexdocs.pm/elixir/1.17.2/compatibility-and-deprecations.html),\n  so support for Elixir 1.12.\n  ([#94](https://github.com/randycoulman/mix_test_interactive/pull/94))\n\nThere are no actual breaking changes in the code itself, so as long as you're on\nElixir 1.13 or later, you should have no problems upgrading to this version.","title":"💥 BREAKING CHANGE 💥 - Changelog","ref":"changelog.html#breaking-change"},{"type":"extras","doc":"- Update to the latest version of [ex_doc](https://hexdocs.pm/ex_doc/readme.html). The [documentation](https://hexdocs.pm/mix_test_interactive/readme.html) reflects these changes. ([#93](https://github.com/randycoulman/mix_test_interactive/pull/93))\n\n## [v2.1.0](https://github.com/randycoulman/mix_test_interactive/compare/v2.0.4...v2.1.0) - 2024-07-13","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"- Fix compiler warnings on Elixir 1.17. ([#89](https://github.com/randycoulman/mix_test_interactive/pull/89) - Thanks [@jfpedroza](https://github.com/jfpedroza)!)\n\n## [v2.0.4](https://github.com/randycoulman/mix_test_interactive/compare/v2.0.3...v2.0.4) - 2024-03-04","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"- Ignore some filesystem events emitted by inotify. Some events are triggered later than others and end up causing the tests to run twice for a single file change. ([#86](https://github.com/randycoulman/mix_test_interactive/pull/86) - Thanks\n  [@jwilger](https://github.com/jwilger)!)\n\n## [v2.0.3](https://github.com/randycoulman/mix_test_interactive/compare/v2.0.2...v2.0.3) - 2024-01-27","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"- Update `file_system` dependency to allow versions 0.2 and 1.0 to avoid dependency conflicts with popular libraries like `phoenix_live_reload`. Previously, we'd specified v0.3, but there is no such version of `file_system`. ([#83](https://github.com/randycoulman/mix_test_interactive/pull/83))\n\n## [v2.0.2](https://github.com/randycoulman/mix_test_interactive/compare/v2.0.1...v2.0.2) - 2024-01-25","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"- Allow `file_system` versions 0.3 and 1.0 to avoid dependency conflicts with popular libraries like `phoenix_live_reload`. ([#81](https://github.com/randycoulman/mix_test_interactive/pull/81))\n\n## [v2.0.1](https://github.com/randycoulman/mix_test_interactive/compare/v2.0.0...v2.0.1) - 2024-01-25","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"- Make the `styler` dependency a dev-only dependency to avoid pulling it into client projects with a potential version conflict. ([#79](https://github.com/randycoulman/mix_test_interactive/pull/79))\n\n## [v2.0.0](https://github.com/randycoulman/mix_test_interactive/compare/v1.2.1...v2.0.0) - 2024-01-22","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"- This release drops support for older Elixir versions. We officially support the\n  [same versions as Elixir\n  itself](https://hexdocs.pm/elixir/1.16.0/compatibility-and-deprecations.html),\n  so support for Elixir 1.11 and prior has been dropped.\n  ([#67](https://github.com/randycoulman/mix_test_interactive/pull/67),\n  [#75](https://github.com/randycoulman/mix_test_interactive/pull/75))\n- Upgrade [file_system](https://hex.pm/packages/file_system) dependency to\n  version 1.0. This appears to be a simple bump to 1.0 with no breaking changes,\n  so should be safe to upgrade to. It might break dependency resolution\n  if you're locked to a pre-1.0 version, so it's noted here.\n  ([#72](https://github.com/randycoulman/mix_test_interactive/pull/72) - Thanks\n  [@andyl](https://github.com/andyl)!)\n\nThere are no actual breaking changes, so as long as you're on Elixir 1.12 or\nlater and aren't depending on a pre-1.0 version of `file_system`, you should\nhave no problems upgrading to this version.","title":"💥 BREAKING CHANGES 💥 - Changelog","ref":"changelog.html#breaking-changes"},{"type":"extras","doc":"- Add full task documentation. `mix help test.interactive` will now show a\n  summary of usage and configuration information ([#70](https://github.com/randycoulman/mix_test_interactive/pull/70))\n\n- Add support for newer `mix test` options ([#71](https://github.com/randycoulman/mix_test_interactive/pull/71))\n\n## [v1.2.2](https://github.com/randycoulman/mix_test_interactive/compare/v1.2.1...v1.2.2) - 2022-11-15\n\nNo functional changes; purely administrative.","title":"Added - Changelog","ref":"changelog.html#added"},{"type":"extras","doc":"- Migrated repository ownership from @influxdata to @randycoulman ([#60](https://github.com/randycoulman/mix_test_interactive/pull/60))\n\n## [v1.2.1](https://github.com/randycoulman/mix_test_interactive/compare/v1.2.0...v1.2.1) - 2022-06-01","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"- Include .heex in list of watched file extensions\n  ([#57](https://github.com/randycoulman/mix_test_interactive/pull/57) - Thanks @juddey!)\n\n## [v1.2.0](https://github.com/randycoulman/mix_test_interactive/compare/v1.1.0...v1.2.0) - 2022-04-07","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"- Now tested against Elixir 1.12 and 1.13. ([#55](https://github.com/randycoulman/mix_test_interactive/pull/55))\n- Misc. dependency upgrades. ([#55](https://github.com/randycoulman/mix_test_interactive/pull/55))","title":"Changed - Changelog","ref":"changelog.html#changed"},{"type":"extras","doc":"- Include proper source ref in the generated documentation so that it now points at the correct version of the source code. ([#51](https://github.com/randycoulman/mix_test_interactive/pull/51) - Thanks @kianmeng!)\n\n- Include license and changelog in generated documentation. ([#51](https://github.com/randycoulman/mix_test_interactive/pull/51) - Thanks @kianmeng!)\n\n## [v1.1.0](https://github.com/randycoulman/mix_test_interactive/compare/v1.0.1...v1.1.0) - 2021-10-08","title":"Documentation - Changelog","ref":"changelog.html#documentation"},{"type":"extras","doc":"- The `p` (pattern) command now works properly in umbrella projects. Previously, it was unable to find any test files in order to filter the pattern and would therefore not run any tests. Now, in an umbrella project, `mix test.interactive` looks for test files in `apps/*/test` by default, but still respects the `:test_paths` config option used by `mix test`. ([#48](https://github.com/randycoulman/mix_test_interactive/pull/48))","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"- Fixed the spelling of Louis Pilfold's name in the README. Sorry, Louis! 🤦‍♂️ ([#49](https://github.com/randycoulman/mix_test_interactive/pull/49))\n\n## [v1.0.1](https://github.com/randycoulman/mix_test_interactive/compare/v1.0.0...v1.0.1) - 2021-03-09","title":"Documentation - Changelog","ref":"changelog.html#documentation"},{"type":"extras","doc":"- Eliminates a GenServer call timeout that can occur if a command is typed while a long-running test run is in progress. ([#44](https://github.com/randycoulman/mix_test_interactive/pull/44)).\n\n## [v1.0.0](https://github.com/randycoulman/mix_test_interactive/compare/14eb50c742a042de7bfc37c41b8af68d839eb443...v1.0.0) - 2021-02-18\n\n🎉 Happy Birthday!\n\nThe following sections describe changes from [mix-test.watch](https://github.com/lpil/mix-test.watch), which served as the basis of this project.","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"- Interactive mode allows dynamically filtering test files based on a substring pattern or switching to run only failed or stale tests without having to restart.\n\n- File-watching mode can be turned on and off, either by passing `--no-watch` on the command line, or by using the `w` command to dynamically toggle watch mode on and off. When file-watching mode is on, tests will be run in response to file changes as with `mix-test.watch`. When off, tests must be run explicitly using the `Enter` key or by using another command that changes the set of tests to be run.","title":"Added - Changelog","ref":"changelog.html#added"},{"type":"extras","doc":"- It is no longer possible to customize the CLI executable. We always use `mix`. Previously, this allowed the use of `iex -S mix` instead, but that doesn't work well with interactive mode.\n\n- It is no longer possible to specify multiple tasks to run on file changes. This ability added complexity and the feature didn't work very well because it assumed that all tasks would take the exact same set of command-line arguments. It is still possible to specify a different task name than `test`, but `mix test.interactive` assumes that the custom task accepts the same command-line arguments as `mix test`.","title":"Removed - Changelog","ref":"changelog.html#removed"},{"type":"extras","doc":"- On Windows, `mix test.interactive` runs the correct `mix` task, including a custom task provided in the configuration, rather than always running `mix test`. It also passes along other provided command-line arguments as well as those injected by `mix test.interactive`.","title":"Fixed - Changelog","ref":"changelog.html#fixed"},{"type":"extras","doc":"# MIT License\n\nCopyright (c) 2021 Randy Coulman\n\nPermission is hereby granted, free of charge, to any person obtaining a copy\nof this software and associated documentation files (the \"Software\"), to deal\nin the Software without restriction, including without limitation the rights\nto use, copy, modify, merge, publish, distribute, sublicense, and/or sell\ncopies of the Software, and to permit persons to whom the Software is\nfurnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all\ncopies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR\nIMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,\nFITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE\nAUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER\nLIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,\nOUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE\nSOFTWARE.","title":"License","ref":"license.html"},{"type":"extras","doc":"# mix test.interactive\n\n[![Build\nStatus](https://github.com/randycoulman/mix_test_interactive/actions/workflows/ci.yml/badge.svg)](https://github.com/randycoulman/mix_test_interactive/actions)\n[![Module\nVersion](https://img.shields.io/hexpm/v/mix_test_interactive.svg)](https://hex.pm/packages/mix_test_interactive)\n[![Hex\nDocs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/mix_test_interactive/)\n[![License](https://img.shields.io/hexpm/l/mix_test_interactive.svg)](https://github.com/randycoulman/mix_test_interactive/blob/master/LICENSE.md)\n\n`mix test.interactive` is an interactive test runner for ExUnit tests.\n\nBased on Louis Pilfold's wonderful\n[mix-test.watch](https://github.com/lpil/mix-test.watch) and inspired by Jest's\ninteractive watch mode, `mix test.interactive` allows you to dynamically change\nwhich tests should be run with a few keystrokes.\n\nIt allows you to easily switch between running all tests, stale tests, or failed\ntests. Or, you can run only the tests whose filenames contain a substring. You\ncan also control which tags are included or excluded, modify the maximum number\nof failures allowed, repeat the test suite until a failure occurs, specify the\ntest seed to use, and toggle tracing on and off. Includes an optional \"watch\nmode\" which runs tests after every file change.","title":"Overview","ref":"readme.html"},{"type":"extras","doc":"`mix test.interactive` can be added as a dependency to your project, or it can\nbe run from an Elixir script without being added to your project.","title":"Installation - Overview","ref":"readme.html#installation"},{"type":"extras","doc":"To install `mix test.interactive` as a dependency of your project, making it\navailable to anyone working in the project, add `mix_test_interactive` to the\nlist of dependencies in your project's `mix.exs` file:\n\n```elixir\ndef deps do\n  [\n    {:mix_test_interactive, \"~> 4.1\", only: :dev, runtime: false}\n  ]\nend\n```","title":"Installing as a Dependency - Overview","ref":"readme.html#installing-as-a-dependency"},{"type":"extras","doc":"If you are working on a 3rd-party project, you may not be able to add\n`mix test.interactive` as a dependency. In this case, it is possible\nto invoke `mix test.interactive` from an Elixir script.\n\nTo accomplish this, put the following script somewhere on your PATH and make it\nexecutable.\n\n```elixir\n#!/usr/bin/env elixir\n\nMix.install([\n  {:mix_test_interactive, \"~> 4.1\"}\n])\n\nMixTestInteractive.run(System.argv())\n```\n\nAs an example, let's assume you've named the script `mti_exec`.\n\nNow you can `cd` to the project's root directory, and run `mti_exec`. The script\nwill accept all of `mix_test_interactive`'s [command-line options](#options) and\nallow you to use any of its [interactive commands](#interactive-commands).","title":"Running from an Elixir Script - Overview","ref":"readme.html#running-from-an-elixir-script"},{"type":"extras","doc":"```shell\nmix test.interactive   [--  ]\nmix test.interactive  \nmix test.interactive --help\nmix test.interactive --version\n```\n\nYour tests will run immediately (and every time a file changes).","title":"Usage - Overview","ref":"readme.html#usage"},{"type":"extras","doc":"`mix test.interactive` understands the following options, most of which\ncorrespond to configuration settings below.\n\nNote that, if you want to pass both mix test.interactive options and mix test\narguments, you must separate them with `--`.\n\nIf an option is provided on the command line, it will override the same option\nspecified in the configuration.\n\n- `--(no-)clear`: Clear the console before each run (default `false`).\n- `--command   [--arg  ]`: Custom command and arguments for running\n  tests (default: \"mix\" with no arguments). NOTE: Use `--arg` multiple times to\n  specify more than one argument.\n- `--exclude  `: Exclude files/directories from triggering test runs\n  (default: `[\"~r/\\.#/\", \"~r{priv/repo/migrations}\"`]) NOTE: Use `--exclude`\n  multiple times to specify more than one regex.\n- `--extra-extensions  `: Watch files with additional extensions\n  (default: []).\n- `--runner  `: Use a custom runner module (default:\n  `MixTestInteractive.PortRunner`).\n- `--task  `: Run a different mix task (default: `\"test\"`).\n- `--(no-)timestamp`: Display the current time before running the tests\n  (default: `false`).\n- `--(no-)watch`: Don't run tests when a file changes (default: `true`).\n\nAll of the ` ` are passed through to `mix test` on every test\nrun.\n\n`mix test.interactive` will detect the `--exclude`, `--failed`, `--include`,\n`--only`, `--seed`, and `--stale` options and use those as initial settings in\ninteractive mode. You can then use the interactive mode commands to adjust those\noptions as needed. It will also detect any filename or pattern arguments and use\nthose as initial settings. Note that if you specify a pattern on the\ncommand-line, `mix test.interactive` will find all test files matching that\npattern and pass those to `mix test` as if you had used the `p` command.","title":"Options - Overview","ref":"readme.html#options"},{"type":"extras","doc":"`mix test.interactive` can take the same filename or filename:line_number\npatterns that `mix test` understands. It also allows you to specify one or more\n\"patterns\" - strings that match one or more test files. When you provide one or\nmore patterns on the command-line, `mix test.interactive` will find all test\nfiles matching those patterns and pass them to `mix test` as if you had used the\n`p` command (described below).","title":"Patterns and filenames - Overview","ref":"readme.html#patterns-and-filenames"},{"type":"extras","doc":"After the tests run, you can use the interactive commands to change which tests\nwill run.\n\n- `a`: Run all tests. Clears the `--failed` and `--stale` options as well as\n  any patterns.\n- `d  `: Run the tests with a specific seed.\n- `d`: Clear any previously specified seed.\n- `f`: Run only tests that failed on the last run (equivalent to the\n  `--failed` option of `mix test`).\n- `i  `: Include tests tagged with the listed tags (equivalent to the\n  `--include` option of `mix test`).\n- `i`: Clear any included tags.\n- `m  `: Specify the maximum number of failures allowed (equivalent to the\n  `--max-failures` option of `mix test`).\n- `m`: Clear any previously specified maximum number of failures.\n- `o  `: Run only tests tagged with the listed tags (equivalent to the\n  `--only` option of `mix test`).\n- `o`: Clear any \"only\" tags.\n- `p`: Run only test files that match one or more provided patterns. A pattern\n  is the project-root-relative path to a test file (with or without a line\n  number specification) or a string that matches a portion of full pathname.\n  e.g. `test/my_project/my_test.exs`, `test/my_project/my_test.exs:12:24` or\n  `my`.\n- `q`: Exit the program. (Can also use `Ctrl-D`.)\n- `r  `: (Elixir 1.17.0 and later) Run tests up to   times until a\n  failure occurs (equivalent to the `--repeat-until-failure` option of `mix\ntest`).\n- `r`: (Elixir 1.17.0 and later) Clear the \"repeat-until-failure\" count.\n- `s`: Run only test files that reference modules that have changed since the\n  last run (equivalent to the `--stale` option of `mix test`).\n- `t`: Turn test tracing on or off (equivalent to the `--trace` option of `mix\ntest`).\n- `x  `: Exclude tests tagged with the listed tags (equivalent to the\n  `--exclude` option of `mix test`).\n- `x`: Clear any excluded tags.\n- `w`: Turn file-watching mode on or off.\n- `Enter`: Re-run the current set of tests without requiring a file change.\n- `?`: Show usage help.","title":"Interactive Commands - Overview","ref":"readme.html#interactive-commands"},{"type":"extras","doc":"`mix test.interactive` can be configured with various options using application\nconfiguration. You can also use command line arguments to specify these\nconfiguration options, or to override configured options.\n\n### `clear`: Clear the console before each run\n\nIf you want `mix test.interactive` to clear the console before each run, you can\nenable this option in your config/dev.exs as follows:\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    clear: true\nend\n```\n\n### `command`: Use a custom command\n\nBy default, `mix test.interactive` uses `mix test` to run tests.\n\nYou might want to provide a custom command that does other things before or\nafter running `mix`. In that case, you can customize the command used for\nrunning tests.\n\nFor example, you might want to provide a name for the test runner process to\nallow connection from other Erlang nodes. Or you might want to run other\ncommands before or after running the tests.\n\nIn those cases, you can customize the command that `mix test.interactive` will\nuse to run your tests. `mix test.interactive` assumes that the custom command\nultimately runs `mix` under the hood (or at least accepts all of the same\ncommand-line arguments as `mix`). The custom command can either be a string or a\n`{command, [..args..]}` tuple.\n\nExamples:\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    command: \"path/to/my/test_runner.sh\"\nend\n```\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    command: {\"elixir\", [\"--sname\", \"name\", \"-S\", \"mix\"]}\nend\n```\n\nTo run a different mix task instead, see the `task` option below.\n\n### `exclude`: Excluding files or directories\n\nTo stop changes to specific files or directories from triggering test runs, you\ncan add `exclude:` regexp patterns to your config in `mix.exs`:\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    exclude: [~r/db_migration\\/.*/,\n              ~r/useless_.*\\.exs/]\nend\n```\n\nThe default is `exclude: [~r/\\.#/, ~r{priv/repo/migrations}]`.\n\n### `extra_extensions`: Watch files with additional extensions\n\nBy default, `mix test.interactive` will trigger a test run when a known Elixir\nor Erlang file has changed, but not when any other file changes.\n\nYou can specify additional file extensions to be included with the\n`extra_extensions` option.\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    extra_extensions: [\"json\"]\nend\n```\n\n`mix test.interactive` always watches files with the following extensions:\n`.erl`, `.ex`, `.exs`, `.eex`, `.leex`, `.heex`, `.xrl`, `.yrl`, and `.hrl`. To\nignore files with any of these extensions, you can specify an `exclude` regexp\n(see above).\n\n### `runner`: Use a custom runner module\n\nBy default `mix test.interactive` uses an internal module named\n`MixTestInteractive.PortRunner` to run the tests. If you want to run the tests\nin a different way, you can supply your own runner module instead. Your module\nmust implement the `MixTestInteractive.TestRunner` behaviour, either implicitly\nor explicitly.\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    runner: MyApp.FancyTestRunner\nend\n```\n\n### `task`: Run a different mix task\n\nBy default, `mix test.interactive` runs `mix test`.\n\nThrough the mix config it is possible to run a different mix task. `mix\ntest.interactive` assumes that this alternative task accepts the same\ncommand-line arguments as `mix test`.\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    task: \"custom_test_task\"\nend\n```\n\nThe task is run with `MIX_ENV` set to `test`.\n\nTo use a custom command instead, see the `command` option above.\n\n### `timestamp`: Display the current time before running the tests\n\nWhen `timestamp` is set to true, `mix test.interactive` will display the current\ntime (UTC) just before running the tests.\n\n```elixir\n# config/config.exs\nimport Config\n\nif Mix.env == :dev do\n  config :mix_test_interactive,\n    timestamp: true\nend\n```","title":"Configuration - Overview","ref":"readme.html#configuration"},{"type":"extras","doc":"On Linux you may need to install `inotify-tools`.","title":"Compatibility Notes - Overview","ref":"readme.html#compatibility-notes"},{"type":"extras","doc":"You can enable desktop notifications with\n[ex_unit_notifier](https://github.com/navinpeiris/ex_unit_notifier).","title":"Desktop Notifications - Overview","ref":"readme.html#desktop-notifications"},{"type":"extras","doc":"This project started as a clone of the wonderful\n[mix-test.watch](https://github.com/lpil/mix-test.watch) project, which I've\nused and loved for years. I've added the interactive mode features to the\nexisting feature set.\n\nThe idea for having an interactive mode comes from [Jest](https://jestjs.io/)\nand its incredibly useful interactive watch mode.","title":"Acknowledgements - Overview","ref":"readme.html#acknowledgements"},{"type":"extras","doc":"Copyright (c) 2021-2024 Randy Coulman\n\nThis work is free. You can redistribute it and/or modify it under the terms of\nthe MIT License. See the [LICENSE.md](./LICENSE.md) file for more details.","title":"Copyright and License - Overview","ref":"readme.html#copyright-and-license"}],"proglang":"elixir","content_type":"text/markdown","producer":{"name":"ex_doc","version":"0.35.1"}}